# Imagine

<mark style="color:green;">`POST`</mark> `https://api.apiframe.pro/flux-imagine`

**Headers**

| Name                                            | Value                 |
| ----------------------------------------------- | --------------------- |
| Content-Type                                    | `application/json`    |
| Authorization<mark style="color:red;">\*</mark> | Your APIFRAME API Key |

**Body**

<table><thead><tr><th width="206">Name</th><th width="107">Type</th><th>Description</th></tr></thead><tbody><tr><td><code>model</code><mark style="color:red;"><code>*</code></mark></td><td>string</td><td>The model to use for the generation; It can be 'flux-schnell', 'flux-pro', 'flux-dev', 'flux-pro-1.1', or 'flux-pro-1.1-ultra'</td></tr><tr><td><code>prompt</code><mark style="color:red;"><code>*</code></mark></td><td>string</td><td>the text prompt to describe the image to generate</td></tr><tr><td><code>image_prompt</code></td><td>string</td><td>Optional base64 encoded image to use for image-to-image</td></tr><tr><td><code>image_prompt_strength</code></td><td>float</td><td>Should be a float between 0 and 1<br>Only for 'flux-pro-1.1-ultra'</td></tr><tr><td><code>prompt_upsampling</code></td><td>boolean</td><td>Whether to perform upsampling on the prompt. If active, automatically modifies the prompt for more creative generation.</td></tr><tr><td><code>width</code></td><td>integer</td><td>The width of the image to generate, min 256 and max 1440. Default: 1024</td></tr><tr><td><code>height</code></td><td>integer</td><td>The height of the image to generate, min 256 and max 1440. Default: 768</td></tr><tr><td><code>aspect_ratio</code></td><td>string</td><td>Aspect ratio of the image between 21:9 and 9:21<br>Default: 16:9<br>Only for flux-pro-1.1-ultra'</td></tr><tr><td><code>steps</code></td><td>integer</td><td>Number of steps for the image generation process. Only for 'flux-pro' and 'flux-dev'</td></tr><tr><td><code>guidance</code></td><td>float</td><td>Guidance scale for image generation. High guidance scales improve prompt adherence at the cost of reduced realism.<br>Only for 'flux-pro' and 'flux-dev'</td></tr><tr><td><code>interval</code></td><td>integer</td><td>Interval parameter for guidance control. Default: 2<br>Min: 1, Max: 4<br>Only for 'flux-pro'</td></tr><tr><td><code>seed</code></td><td>integer</td><td>The seed to use for the generation</td></tr><tr><td><code>safety_tolerance</code></td><td>integer</td><td>Tolerance level for input and output moderation. Between 0 and 6, 0 being most strict, 6 being least strict.</td></tr><tr><td><code>raw</code></td><td>boolean</td><td>Generate less processed, more natural-looking images<br>Only for flux-pro-1.1-ultra'</td></tr><tr><td><code>webhook_url</code></td><td>string</td><td>The final result and updates of this task will be posted at this URL.</td></tr><tr><td><code>webhook_secret</code></td><td>string</td><td>Will be passed as <code>x-webhook-secret</code> in the webhook call headers for authentication.</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
// Success, the task has been submitted
{
    "task_id": "64cd7965-1b78-42c8-b929-9d7751a2e149"
}
```

{% endtab %}

{% tab title="400" %}

```json
// Bad request
{
  "errors": [{ msg: "Invalid request" }]
}
```

{% endtab %}

{% tab title="401" %}

```json
// Invalid API Key
{}
```

{% endtab %}

{% tab title="500" %}

```json
// A server error occured
{}
```

{% endtab %}
{% endtabs %}

This endpoint doesn't generate images instantly, you can use the [Fetch](/api-endpoints/fetch.md) endpoint to fetch the result or use [webhooks](/webhooks.md).

The result (posted to the `webhook_url` or retrieved with the [Fetch](/api-endpoints/fetch.md) endpoint) looks like this:

```json
{
    "task_id": "29e983ca-7e86-4017-a9e3-ef6fe9cd5f2a",
    "task_type": "flux-imagine",
    "original_image_url": "https://.../xxxxxxxx.png", // grid image
    "image_url": "https://.../xxxxxxxx.png"
}
```

If the job is not completed, you will get a result like this:

```json
{
    "task_id": "29e983ca-7e86-4017-a9e3-ef6fe9cd5f2a",
    "task_type": "flux-imagine",
    "status": "processing",
    "percentage": 40
}
```

Code samples

{% tabs %}
{% tab title="JavaScript" %}

```javascript
const axios = require('axios');
const data = JSON.stringify({
  "prompt": "a sunflower field in the wind",
  "model": "flux-pro"
});

const config = {
  method: 'post',
  maxBodyLength: Infinity,
  url: 'https://api.apiframe.pro/flux-imagine',
  headers: { 
    'Content-Type': 'application/json', 
    'Authorization': 'YOUR_API_KEY'
  },
  data : data
};

axios.request(config)
.then((response) => {
  console.log(JSON.stringify(response.data));
})
.catch((error) => {
  console.log(error);
});

```

{% endtab %}

{% tab title="Python" %}

```python
import requests
import json

url = "https://api.apiframe.pro/flux-imagine"

payload = json.dumps({
  "prompt": "a sunflower field in the wind",
  "model": "flux-pro"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'YOUR_API_KEY'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)

```

{% endtab %}

{% tab title="PHP" %}

```php



```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.apiframe.ai/flux/imagine.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
